/*  bidiEpson.h -- EPSON Credit-Based Transport - Header file
 *  Copyright (C) 2003  EPSON KOWA Corporation
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

/* $Id: bidiEpson.h,v 1.5 2004/02/23 01:29:31 kitayama Exp $ */

#ifndef ECBT_H
#define ECBT_H

#ifdef HAVE_CONFIG_H
#include <config.h>
#endif

#include <sys/types.h>


typedef int bool;

#ifndef FALSE
#define FALSE 0
#endif

#ifndef TRUE
#define TRUE (!FALSE)
#endif

/** Channel ID's */
typedef enum CH_ID {
	CHID_TRANSACTION = 0x00, /**< ȥ󥶥ͥ */
	CHID_COMMAND = 0x02,	/**< ޥɥͥ */
	CHID_DATA = 0x40	/**< ǡͥ */
} ChID;

/** Error Codes */
typedef enum ECBT_ERR_CODE {
	ECBT_ERR_NOERR = 0,	/**<  */
	ECBT_ERR_PARAM,		/**< ѥ᡼̵ */
	ECBT_ERR_NOCONNECT,	/**< ̿顼 */
	ECBT_ERR_BUSY,		/**< ץ󥿤ӥ */
	ECBT_ERR_CHREOPN,	/**< Cannelϴ˥ץ󤷤Ƥ */
	ECBT_ERR_CHNOPN,	/**< Cannelϥץ󤷤Ƥʤ */
	ECBT_ERR_NOMEM,		/**< ꡼ݽʤ */
	ECBT_ERR_SIGNAL,	/**< ʥ˳ޤ줿 */
	ECBT_ERR_SYSTEM,    /**< ݡȤʤƥॳ륨顼 */
	ECBT_ERR_UNCONF,	/**< ̿̿Ū礬ȯ */
	ECBT_ERR_FATAL		/**< ͽʤ顼 */
} EcbtErrCode;

/** ECBTϥɥ */
typedef void * EcbtHandle;

#ifdef __cplusplus
extern "C" {
#endif /* __cplusplus */
EcbtErrCode EcbtOpen(EcbtHandle *, int);
EcbtErrCode EcbtClose(EcbtHandle);
EcbtErrCode EcbtChannelOpen(EcbtHandle, int);
EcbtErrCode EcbtChannelClose(EcbtHandle, int);
EcbtErrCode EcbtWrite(EcbtHandle, int, void *, size_t, ssize_t *);
EcbtErrCode EcbtRead(EcbtHandle, int, void *, size_t, ssize_t *);
#ifdef __cplusplus
}
#endif /* __cplusplus */

extern int signalCatchedFlag;

#endif /* ECBT_H */
