/* bidiEpsonStatus.h -- for Printer Status
 * Copyright (C) 2003 EPSON KOWA Corporation
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

/* $Id: bidiEpsonStatus.h,v 1.10 2004/02/16 11:21:31 toko Exp $ */

#ifndef BIDIEPSONSTATUS_H
#define BIDIEPSONSTATUS_H

#ifdef HAVE_CONFIG_H
#include <config.h>
#endif


#define STATUS_RS	';'							/**< record separator */
#define STATUS_FS	','							/**< field separator */
#define STATUS_EOR	''						/**< End of record */


/** ץ󥿤Υơ */
#define STATUS_ERROR		0
#define STATUS_PRINTING		1
#define STATUS_BUSY			2
#define STATUS_WAIT			3
#define STATUS_IDLE			4
#define STATUS_IMPOSSIBLE	5
#define STATUS_INK_DRY		6
#define STATUS_CLEANING		7
#define STATUS_FACTORY_DEFAULT	8
#define STATUS_MOTOR_OFF	9
#define STATUS_SHUTTINGDOWN	10
#define STATUS_WAIT_INIT	11
#define STATUS_INITIALIZING	12


#ifdef __cplusplus
extern "C" {
#endif /* __cplusplus */

void *initStatus(void);
bool setStatus(void *p, char *status, int strLength);
bool makeXml(void *p, char *xml, int xmlLength, char *pLang);

int isPrinting(void *sl);
int isIdling(void *sl);

#ifdef __cplusplus
}
#endif /* __cplusplus */

#endif /* BIDIEPSONSTATUS_H */
