/* bidiLibEpson.h -- Bidi for EPSON Ink Jet Printer.
 * Copyright (C) 2003 EPSON KOWA Corporation
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

/* $Id: bidiLibEpson.h,v 1.10 2004/02/17 18:04:09 toko Exp $ */

#ifndef _BIDILIB_EPSON_H
#define _BIDILIB_EPSON_H

#define XML_BUFFER_SIZE 11000

//#define THREAD_WRITE_LIST_MAX			1024		/* write thread ѤꥹȤκĿ */
#define THREAD_WRITE_LIST_MAX			4			/**< write thread ѤꥹȤκĿ */
//#define THREAD_WRITE_LIST_MAX			2			/* write thread ѤꥹȤκĿ */


/**  write ׵ξ */
typedef struct writeRequestInfo_t {
	char	*buf;					/**< write ٤ǡ */
	int		offset;					/**< buf γϰ */
	int		size;					/**< 񤭹Ĺ */
} writeRequestInfo;

/** write ׵ѹ¤ */
typedef struct writeRequestList_t {
	int					number;					/**< write ׵θĿ */
	int					startIndex;				/**< write γϥǥå */
	int					appendIndex;			/**< write ׵ɲóϥǥå */
	writeRequestInfo	wrq[THREAD_WRITE_LIST_MAX];	/**< write ׵ */
} writeRequestList;

/** signal  */
typedef struct savedSignal_t {
	sig_t	term;
	sig_t	pipe;
	sig_t	hup;
	sig_t	alrm;
} savedSignal;


/** Library ʬδѹ¤ */
typedef struct {
    int		fdRead;						/**< read ѥեǥץ */
    int		fdWrite;					/**< write ѥեǥץ */
    char	*uri;						/**< uri  */
    int		isPrinterUp;				/**< ץ󥿤֤ˤʤäȤ򼨤ե饰 */
    int		idJob;	        			/**< ߤ idJob */
    char	xmlBuf[XML_BUFFER_SIZE];	/**<  XML ѤΥХåե */
    int		xmlSize;        			/**< Хåե XML ΥХȥ */
    int		pXmlBuf;        			/**< ХåեXMLνѥݥ */

	bool	commError;					/**< ץ󥿤Ȥ̿顼̵ͭ */

	bool	dataChannelOpenRequest;		/**< data channel  ץꥯ */
	int		dataChannelOpend;			/**< data channel  ץѤߥե饰 */
	void	*printerStatus;				/**< ץ󥿤Υơ */

	int			RdThreadValid;		/**< read thread ưƤ뤫ݤ */
	pthread_t	RdThread;			/**< read thread  */
	int			WrThreadValid;		/**< write thread ưƤ뤫ݤ */
	pthread_t	WrThread;			/**< write thread  */
	pthread_mutex_t	mutexStatus;	/**< ץ󥿥ơʸ mutex */
	pthread_mutex_t	mutexIO;		/**< ץ󥿤 I/O  mutex */
	pthread_mutex_t	mutexBuffer;	/**< write ׵ѹ¤Τѹ mutex */

	pthread_cond_t	condDataBuffer;	/**< write ׵λ cond */


	int		statusRead;				/**< ץ󥿤Υơɤ߹ߺѤߥե饰 */

	// data channel 
	writeRequestList	dataWriteRequestList; /**< ǡͥؤ write ׵ꥹ */

	// command channel 
	writeRequestList	commandWriteRequestList; /**< ޥɥͥؤ write ׵ꥹ */

	void *cbtHdl;					/**< CBT ѥϥɥ */
} BidiLibC;



bool CanDataWriteRequest(void *pBidiLibC, struct timespec *nWaitVal);
bool IsPrinterCommunicationError(void *pBidiLibC);



/* Bidi Plug-in Internal APIs for Shared Lib Type  */
void *bidiLibNew(int fdRead, int fdWrite, char *pURI);

void bidiLibDestroy(void *pBidiLibC);

int bidiLibGetCap(void *pBidiLibC, BidiCap cap);

int bidiLibStartJob(void *pBidiLibC, int idJob);

int bidiLibEndJob(void *pBidiLibC);

int bidiLibCancelJob(void *pBidiLibC, int idJob);

int bidiLibGetReadFD(void *pBidiLibC);

int bidiLibStartRead(void *pBidiLibC, BidiReadMode idReadMode, char *pLang);

int bidiLibRead(void *pBidiLibC, void *pBuf, int nBufBytes);

int bidiLibEndRead(void *pBidiLibC);

int bidiLibGetWriteFD(void *pBidiLibC);

int bidiLibStartWrite(void *pBidiLibC);

int bidiLibWrite(void *pBidiLibC, void *pBuf, int nBufBytes);

int bidiLibEndWrite(void *pBidiLibC);

int bidiLibCtrl(void *pBidiLibC, int idRequest, void *pData, int nDataBytes);

#endif
