/* bidiProc.h -- Bidi Process Type.
 * Copyright (C) 2003 EPSON KOWA Corporation
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

/* $Id: bidiProc.h,v 1.5 2004/02/16 11:21:31 toko Exp $ */

#ifndef BIDI_PROC_H
#define BIDI_PROC_H



/** enum type used in bidiGetCap */
typedef enum {
    BIDI_CAP_WRITE = 1,
    BIDI_CAP_JOB   = 2,
    BIDI_CAP_CTRL  = 3
} BidiCap;


/** enum type shows read mode of print status */
typedef enum {
    BIDI_READ_PRT_MIB_SUMMARY = 1
} BidiReadMode;

/** definitions of constants of return values */
#define BIDI_FALSE          0
#define BIDI_TRUE           1
#define BIDI_OK             0
#define BIDI_ERROR          (-1)
#define BIDI_EINTR          (-2)
#define BIDI_EPROGRESS      (-3)
#define BIDI_ENOJOB         (-4)

/** command IDs used in process type */
#define BIDI_CMD_NEW        0x00000001
#define BIDI_CMD_DESTROY    0x00000002
#define BIDI_CMD_GETCAP     0x00000003
#define BIDI_CMD_STARTJOB   0x00000011
#define BIDI_CMD_ENDJOB     0x00000012
#define BIDI_CMD_CANCELJOB  0x00000013
#define BIDI_CMD_STARTREAD  0x00000021
#define BIDI_CMD_ENDREAD    0x00000022
#define BIDI_CMD_READ       0x00000023
#define BIDI_CMD_STARTWRITE 0x00000031
#define BIDI_CMD_ENDWRITE   0x00000032
#define BIDI_CMD_WRITE      0x00000033
#define BIDI_CMD_CTRL       0x00000034

/** command IDs for response */
#define BIDI_CMD_OK         0x80000000
#define BIDI_CMD_ERROR      0x80000001

#define BIDI_PLUGIN_VERSION 0x00010000


/** enum type shows context status */
typedef enum {
    BIDI_CXT_NORMAL,
    BIDI_CXT_READIN,
    BIDI_CXT_WRITEIN,
    BIDI_CXT_JOBIN
} BidiCxt;

#endif
