/*
 *  OpenPrinting Vector Printer Driver for Canon Pixus850i
 *  Copyright (c) 2004 E&D Inc.
 *  All rights reserved.
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * NOTE:
 *  - As a special exception, this program is permissible to link with the
 *    libraries released as the binary modules.
 *  - If you write modifications of your own for these programs, it is your
 *    choice whether to permit this exception to apply to your modifications.
 *    If you do not wish that, delete this exception.
*/

/* $Revision: 1.2 $ */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "bjp_conf.h"

short
bjp_GetConfID(char *rcFname,
	      char *objString,
	      char *rcString )
{
	FILE *in;
	int rv = BJPCONFERROR;
	char buf[80];
	char *p1, *p2;
	char name[40];
	int value;
	int find = 0;

	if(rcFname == NULL || objString == NULL || rcString == NULL)
		goto onErr;

	in = fopen(rcFname,"r");
	if(in == NULL) goto onErr;

	while(fgets(buf, 80, in) != NULL){
		if(buf[0] == '#')
			continue;
		if((p1=index(buf,'[')) != NULL &&
		   (p2 = rindex(buf,']')) != NULL){
			if(find)
				break;	/* abort if already found */
			*p2 = 0;
			find = !strcmp(objString,p1+1);
		}else if(find && sscanf(buf,"%s %d", name, &value) == 2){
			if(!strcmp(rcString, name)){
				rv = value;
				break;
			}
		}
	}
	fclose(in);

 onErr:
	return(rv);
}
