/*
 *  Canon Bubble Jet Print Filter for Linux
 *  Copyright CANON INC. 2001-2003
 *  All Right Reserved.
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * NOTE:
 *  - As a special exception, this program is permissible to link with the
 *    libraries released as the binary modules.
 *  - If you write modifications of your own for these programs, it is your
 *    choice whether to permit this exception to apply to your modifications.
 *    If you do not wish that, delete this exception.
*/

#ifndef _CNCLUCOM_H_
#define	_CNCLUCOM_H_

typedef struct{
	char	OrgDataBaseName[16];		// Data Base File Name
	long	reserve[20];
} CNCLNAMEINFO, *LPCNCLNAMEINFO;

typedef struct{
	short	nObjectID;					// Object ID
	short	nValue;						// set value
	short	defset;						// default flag
	short	curset;						// current flag
	short	tmpset;						// tmp flag
	short	disable;					// disable flag
} CNCLDB, *LPCNCLDB;

typedef struct BJFLTDEVICE{
	short	bjfltModelID ;			//ID
	short	bjfltInkType ;			//ȥå
	short	bjfltMediaType ;		//ǥ׾
	short	bjfltPaperSize ;		//ѻ極
	short	bjfltMediaSupply ;		//ˡ
	short	bjfltBinMethod ;		//Ͳˡ
	short	bjfltGrayScale ;		//졼
	short	bjfltPrintQuality ;		//ʰ̾
	short	bjfltBanner ;			//Хʡ
	long	bjfltPaperWidth ;		//ѻ極 
	long	bjfltPaperHeight ;		//ѻ極 
	short	bjfltMarginType ;		//ޡ󥿥׾
	short	bjfltPaperGap;
	short	reserve[8];
} BJFLTDEVICE, *LPBJFLTDEVICE;

typedef struct {
	short	bjfltIntent;		//Ū
	short	bjfltGamma;			//
	short	bjfltBalanceC;		//CyanΥ顼Х
	short	bjfltBalanceM;		//MagentaΥ顼Х
	short	bjfltBalanceY;		//YellowΥ顼Х
	short	bjfltBalanceK;		//BlackΥ顼Х
	short	bjfltDensity;		//ǻ
	short	reserv[10];			//ͽ
} BJFLTCOLORSYSTEM, *LPBJFLTCOLORSYSTEM;


typedef struct {
	long	nMinCustomWidth;	// user defined min papersize horizontal
	long	nMaxCustomWidth;	// user defined max papersize horizontal
	long	nMinCustomLength;	// user defined min papersize vertical
	long	nMaxCustomLength;	// user defined max papersize vertical
	long	nSelPaperWidth;		// selected paper width
	long	nSelPaperLength;	// selected paper length
	long	nTopMargin;			// top margin
	long	nLeftMargin;		// left margin
	long	nWidthPrintArea;		// width can print
	long	nLengthPrintArea;	// length can print
} CNCLPAPERSIZE, *LPCNCLPAPERSIZE;

typedef struct {
	short	bjfltInkCartridge;		//CNCL InkType ID.(!= bjfltInkType)
	short	bjfltInputHResolution;	//driver horizontal resolution
	short	bjfltInputVResolution;	//driver vertical resolution
	short	reserv[16];
} BJFLTCOMSYSTEM, *LPBJFLTCOMSYSTEM;

/*-------------------------------------------------------------------
			FUNCTION PROTOTYPES
-------------------------------------------------------------------*/
extern short CNCL_GetDBName( LPCNCLNAMEINFO , void *, short  );
extern short CNCL_GetDBSize( LPCNCLNAMEINFO , void * );
extern short CNCL_GetEntries( LPCNCLNAMEINFO , void *, LPCNCLDB  );
extern short CNCL_GetDefaults( LPCNCLNAMEINFO , void *, LPCNCLDB , short  );
extern short CNCL_InitMenulink( LPCNCLNAMEINFO , void *, LPCNCLDB , short  );
extern short CNCL_GetMenulink( LPCNCLNAMEINFO , void *, LPCNCLDB, short  );
extern short CNCL_GetMargin( LPCNCLNAMEINFO, void *, LPCNCLDB, LPCNCLPAPERSIZE, short );
extern short CNCL_GetComSystem( LPCNCLNAMEINFO, void *, LPBJFLTDEVICE, LPBJFLTCOMSYSTEM );
#endif

