.\" This manpage has been automatically generated by docbook2man 
.\" from a DocBook document.  This tool can be found at:
.\" <http://shell.ipoline.com/~elmert/comp/docbook2X/> 
.\" Please send any bug reports, improvements, comments, patches, 
.\" etc. to Steve Cheng <steve@ggi-project.org>.
.TH "XPRT" "1" "03 April 2003" "" ""
.SH NAME
Xprt \- Print server for X Version 11
.SH SYNOPSIS

\fBXprt\fR [ \fB-ac\fR ] [ \fB-audit \fIlevel\fB\fR ] [ \fB-pn\fR ] [ \fB-fp \fIfontpath\fB\fR ] [ \fB:\fIdisplay\fB\fR ]

.SH "DESCRIPTION"
.PP
\fBXprt\fR is the Xprint print server
for version 11 of the X Window system for non display devices
such as printers and fax machines.
.PP
Xprint is an advanced printing system which enables X11
applications to use devices like printers, FAX or create
documents in formats like PostScript or PDF.  It may be used by
clients such as \fBmozilla\fR.
.PP
Xprint is a very flexible, extensible, scaleable, client/server
print system based on ISO 10175 (and some other specs) and the X11        
rendering protocol.                                                       
Using Xprint an application can search, query and use devices like        
printers, FAX machines or create documents in formats like PDF.           
In particular, an application can seek a printer, query supported         
attributes (like paper size, trays, fonts etc.), configure the printer    
device to match it's needs and print on it like on any other X device     
reusing parts of the code which is used for the video card Xserver.
.SH "USAGE"
.PP
Although Xprt may be invoked from the command line, it is
preferable to run it as a daemon via the init script
/etc/init.d/xprint (where this script exists).
.PP
Client programs such as mozilla will require environment
variable \fBXPSERVERLIST\fR to be set, identifying the
"display" on which Xprt is running.  This variable may be set
for all users via /etc/profile (or similar), using
\fB/etc/init.d/xprint get_xpserverlist\fR:
.PP

.nf
export XPSERVERLIST=`/etc/init.d/xprint get_xpserverlist`
.fi
.SH "OPTIONS"
.PP
Many of Xprt's command line options are shared in common
with the usual X servers (see Xserver (1)). Commonly used options include:
.TP
\fB:\fIdisplay\fB \fR
The X server runs on the given display. If multiple X
servers are to run simultaneously on a host, each must
have a unique display number.  Note that the standard X
server (for video displays) typically runs on display
:0.  If /etc/init.d/xprint is used to invoke Xprt, it
may be configured to automatically assign an available
display number.
.TP
\fB-ac \fR
disables host-based access control mechanisms.  Enables  access
by  any host, and permits any host to modify the access control
list.  Use with extreme caution.  This option exists  primarily
for running test suites remotely.
.TP
\fB-audit \fIlevel\fB \fR
sets  the  audit  trail level.  The default level is 1, meaning
only connection rejections are reported.  Level 2  additionally
reports  all  successful  connections and disconnects.  Level 4
enables messages  from  the  SECURITY  extension,  if  present,
including  generation  and  revocation  of  authorizations  and
violations of the security policy.  Level 0 turns off the audit
trail.  Audit lines are sent as standard error output.
.TP
\fB-fp \fIfontpath\fB \fR
sets the search path for fonts.  This path is a comma
separated list of directories which Xprt searches for
font databases.
.TP
\fB-pn \fR
permits the server to continue running if it fails to
establish all of its well-known sockets (connection
points for clients), but establishes at least
one.
.SH "ENVIRONMENT"
.TP
\fBXPCONFIGDIR \fR
This environment variable points to the  root
of  the Xprint configuration directory hierarchy.
If the variable is not defined,  the  default
path  is be assumed.  The default path may be
/usr/lib/X11/xserver or
/usr/share/Xprint/xserver, depending on the
system, and may be configured in /etc/init.d/xprint.
.TP
\fBXPSERVERLIST \fR
The environment variable \fB${XPSERVERLIST}\fR contains a list
of display identifiers (separated by whitespace) which tell an
application where it can find the Xprint servers.  Usually
\fB${XPSERVERLIST}\fR is set by the profile startup scripts (e.g.
/etc/profile or /etc/profile.d/xprint.sh) using the output of
\fB/etc/init.d/xprint get_xpserverlist\fR.

Example: 
.PP

.nf
		export XPSERVERLIST="`/etc/init.d/xprint get_xpserverlist`"
.fi

Alternatively \fB${XPSERVERLIST}\fR can be set
manually. Example:


.nf
		export XPSERVERLIST="littlecat:80 bitdog:72"
.fi

instructs an application to find an Xprint server at display
80 on the machine "littlecat" and at display 72 on the
machine bigdog.
.TP
\fBXPRINTER \fR
The environment variable \fB${XPRINTER}\fR
defines the default printer used by print
applications. The syntax is either
\fIprintername\fR or
\fIprintername\fR@\fIdisplay\fR.

Examples:
.RS
.TP
\fBXPRINTER=ps003\fR
tells an application to look for the
first printer named "ps003" on all Xprint
servers.
.TP
\fBXPRINTER=hplaser19@littlecat:80\fR
tells an application to use the printer "hplaser19"
on the Xprint server at display 
"littlecat:80".
.RE

If \fB${XPRINTER}\fR is not set the applications
will examine the values of the \fB${PDPRINTER}\fR,
\fB${LPDEST}\fR, and 
\fB${PRINTER}\fR environment variables (in that order).  
.SH "SEE ALSO"
.PP
xplsprinters (1), xphelloworld (1), Xserver (1).
.SH "AUTHOR"
.PP
This manual page was written by Drew Parsons <dparsons@debian.org>, with
some help from the man page at
http://www.sins.com.au/unix/manpages/Xprt.html and the XFree86
man page for Xserver.
